/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/

#include <qapplication.h>
#include <qmessagebox.h>
#include <qregexp.h>
#include <qcolordialog.h>
#include <qpushbutton.h>
#include <qobject.h>
#include <qtooltip.h>
#include "kimeraglobal.h"
#include "config.h"
using namespace Kimera;

const int NUM_ROWS = 4;
const int NUM_COLS = 3;

static QString  ColorSetting[NUM_SETTING_TYPE][NUM_ROWS][NUM_COLS] = { 
  { { QString::null } },       // Current setting (dummy)
  
  { { "black",  "white", "1" },      // MS-IME
    { "black",  "lightGray", "1" }, 
    { "black",  "white", "1" },
    { "white",  "blue",  "0" } },
  
  { { "blue",   "white", "0" },      // ATOK
    { "black",  "cyan",  "0" },
    { "blue",   "white", "0" },
    { "white",  "blue",  "0" } },
  
  { { "black",  "white", "1" },      // KINPUT2
    { "white",  "black", "0" }, 
    { "black",  "white", "1" },
    { "white",  "black", "0" } },
  
  { { "blue",   "gray",  "0" },      // VJE
    { "yellow", "black", "0" }, 
    { "yellow", "blue",  "0" },
    { "gray",   "blue",  "1" } },
};


void PropertyDialog::init()
{
  _colorsetting->setNumRows(NUM_ROWS);
  _colorsetting->setNumCols(NUM_COLS);

  for (int i = 0; i < _colorsetting->numRows(); ++i)
    _colorsetting->setRowStretchable (i ,TRUE);

  for (int i = 0; i < _colorsetting->numCols(); ++i)
    _colorsetting->setColumnStretchable(i ,TRUE);

  _cmbloadcolor->insertItem(tr("ߤ"), ST_CURRENT_SETTING);
  _cmbloadcolor->insertItem(tr("MS-IME"), ST_MSIME);
  _cmbloadcolor->insertItem(tr("ATOK"), ST_ATOK);
  _cmbloadcolor->insertItem(tr("Kinput2"), ST_KINPUT2);
  _cmbloadcolor->insertItem(tr("VJE"), ST_VJE);

  QStringList strlist;
  strlist << tr("ʤ") << tr("");
  for (int i = 0; i < NUM_ROWS; i++) {
    _colorsetting->setItem(i, 2, new QComboTableItem(_colorsetting, strlist));
  }

  QString tip = tr("ʴϤ򳫻Ϥ륭ꤷޤ\nεưͭǤ");
  QToolTip::add(_lblstartkey, tip);
  QToolTip::add(_cmbstartkey, tip);
  tip = tr("ưľϥ⡼ɤ򤷤ޤ");
  QToolTip::add(_lblinputmode, tip);
  QToolTip::add(_cmbinputmode, tip);
  tip = tr("ưľȤ\n޻ϤޤϤϤ򤷤ޤ");
  QToolTip::add(_lblinputstyle, tip);
  QToolTip::add(_cmbinputstyle, tip);

  tip = tr("ڡ򲡤ζʸˤĤ\nȾѤޤѤ򤷤ޤ");
  QToolTip::add(_lblspacekey, tip);
  QToolTip::add(_cmbspacekey, tip);
  tip = tr("ƥ󥭡ϤʸˤĤ\nȾѤޤѤ򤷤ޤ");
  QToolTip::add(_lbltenkey, tip);
  QToolTip::add(_cmbtenkey, tip);
  tip = tr("򤷤ޤ");
  QToolTip::add(_lbltouten, tip);
  QToolTip::add(_cmbtouten, tip);
  tip = tr("򤷤ޤ");
  QToolTip::add(_lblkuten, tip);
  QToolTip::add(_cmbkuten, tip);
  tip = tr("̤򤷤ޤ");
  QToolTip::add(_lblbracket, tip);
  QToolTip::add(_cmbbracket, tip);
  tip = tr("򤷤ޤ");
  QToolTip::add(_lblsymbol, tip);
  QToolTip::add(_cmbsymbol, tip);
  QToolTip::add(_btnkeyassign, tr("ɽޤ"));

  QToolTip::add(_tab4, tr("οover-the-spot\nξͭǤ"));
  QToolTip::add(_cmbloadcolor, tr("ꥹȤ򤵤줿ɤ߹ߤޤ"));
  QToolTip::add(_colorsetting, tr("̤˿ꤷޤ"));

  tip = tr("ʴѴ󥸥򤷤ޤ");
  QToolTip::add(_lblkanjisys, tip);
  QToolTip::add(_cmbkanjisys, tip);
  tip = tr("ʴѴФIPɥ쥹\nޤϥۥ̾ꤷޤ");
  QToolTip::add(_lblsvrname, tip);
  QToolTip::add(_edtsvrname, tip);
  tip = tr("³ݡֹꤷޤ");
  QToolTip::add(_lblport, tip);
  QToolTip::add(_edtport, tip);
}


void PropertyDialog::polish()
{
  _cmbstartkey->setCurrentText(Config::readEntry(_cmbstartkey->name(),
						 _cmbstartkey->currentText()));
  _cmbinputmode->setCurrentText(Config::readEntry(_cmbinputmode->name(), 
						  _cmbinputmode->currentText()));
  _cmbinputstyle->setCurrentText(Config::readEntry(_cmbinputstyle->name(), 
						   _cmbinputstyle->currentText()));
  _chkdispbar->setChecked(Config::readBoolEntry(_chkdispbar->name(), FALSE));
  
  _cmbspacekey->setCurrentText(Config::readEntry(_cmbspacekey->name(),
						 _cmbspacekey->currentText()));
  _cmbtenkey->setCurrentText(Config::readEntry(_cmbtenkey->name(), 
					       _cmbtenkey->currentText()));
  _cmbkuten->setCurrentText(Config::readEntry(_cmbkuten->name(), 
					      _cmbkuten->currentText()));
  _cmbtouten->setCurrentText(Config::readEntry(_cmbtouten->name(), 
					       _cmbtouten->currentText()));
  _cmbsymbol->setCurrentText(Config::readEntry(_cmbsymbol->name(), 
					       _cmbsymbol->currentText()));
  _cmbbracket->setCurrentText(Config::readEntry(_cmbbracket->name(), 
						_cmbbracket->currentText()));

  _cmbkanjisys->setCurrentText(Config::readEntry(_cmbkanjisys->name(), 
						 _cmbkanjisys->currentText()));
  _chkremote->setChecked(Config::readBoolEntry(_chkremote->name(), 
					       _chkremote->isChecked()));
  _edtsvrname->setText(Config::readEntry(_edtsvrname->name(), _edtsvrname->text()));
  _edtport->setText(Config::readEntry(_edtport->name(), _edtport->text()));

  loadColorSetting( ST_CURRENT_SETTING );    // Loads color setting
  QDialog::polish();
}

void PropertyDialog::saveSetteing()
{
  // Check entry
  if (_chkremote->isChecked()) {
    if (_edtsvrname->text().isEmpty() || _edtport->text().isEmpty()) {
      QMessageBox::warning(0, "Incorrect entry", 
			   "Incorrect entry!\nInput Kanji server and port correctly.",
			   QMessageBox::Ok | QMessageBox::Default, 0);

      _tabwdg->showPage(_tab3);  // show page
      return;
      
    } else if ( !_edtport->text().contains(QRegExp("^[0-9]{4,5}$")) ) {
      QMessageBox::warning(0, "Incorrect port number", 
			   "Incorrect port number!\nInput numerical string, 4 or 5 characters.",
			   QMessageBox::Ok | QMessageBox::Default, 0);
      
      _tabwdg->showPage(_tab3);  // show page
      return;
    }
  }
  
  // Saves setting
  Config::writeEntry(_cmbstartkey->name(), _cmbstartkey->currentText());
  Config::writeEntry(_cmbinputmode->name(), _cmbinputmode->currentText());
  Config::writeEntry(_cmbinputstyle->name(), _cmbinputstyle->currentText());
  Config::writeEntry(_chkdispbar->name(), _chkdispbar->isChecked());

  Config::writeEntry(_cmbspacekey->name(), _cmbspacekey->currentText());
  Config::writeEntry(_cmbtenkey->name(), _cmbtenkey->currentText());
  Config::writeEntry(_cmbkuten->name(), _cmbkuten->currentText());
  Config::writeEntry(_cmbtouten->name(), _cmbtouten->currentText());
  Config::writeEntry(_cmbsymbol->name(), _cmbsymbol->currentText());
  Config::writeEntry(_cmbbracket->name(), _cmbbracket->currentText());
  
  Config::writeEntry(_cmbkanjisys->name(), _cmbkanjisys->currentText());
  Config::writeEntry(_chkremote->name(), _chkremote->isChecked());
  Config::writeEntry(_edtsvrname->name(), _edtsvrname->text());
  Config::writeEntry(_edtport->name(), _edtport->text());
  
  saveColorSetting();
  qDebug("Saved settings");
  accept(); 
}


void PropertyDialog::changeColor( int row, int col, int, const QPoint &) 
{
  if (col > 1) return;

  QColor color( white );
  if ( _colorsetting->text(row, col) ) {
    QColor c( _colorsetting->text(row, col) );
    if ( c.isValid() ) color = c;    // default color
  }
  
  // Select color
  color = QColorDialog::getColor(color, this);
  if ( color.isValid() ) {
    QPixmap  pix = _colorsetting->pixmap( row, col );
    pix.resize(_colorsetting->columnWidth(col), _colorsetting->rowHeight(row));
    pix.fill( color );
    _colorsetting->setPixmap(row, col, pix);
    _colorsetting->setText(row, col, color.name());
    qDebug("get color name: %s", color.name().data());
  }
}


void PropertyDialog::execKeyAssiner()
{
  KeyAssigner* dlg = new KeyAssigner();
  dlg->exec();
  delete dlg;
}


void PropertyDialog::loadColorSetting( int index )
{
  qApp->processEvents();

  int i, j;
  switch ( index ) {
  case ST_CURRENT_SETTING:         // Current setting
    // Loads Color table
    for (i = 0; i < NUM_ROWS; i++) {
      for (j = 0; j < NUM_COLS - 1; j++) {
        QColor color(Config::readEntry(QString(_colorsetting->name()) + "color" 
                                       + QString::number(i * 2 + j), "white"));
        if ( color.isValid() ) {
          QPixmap  pix = _colorsetting->pixmap(i, j);
          pix.resize(_colorsetting->columnWidth(j), _colorsetting->rowHeight(i));
          pix.fill( color );
          _colorsetting->setPixmap(i, j, pix);
          _colorsetting->setText(i, j, color.name());
          qDebug("set color row: %d  col: %d  name: %s", i, j, color.name().data());
        }
      }

      QComboTableItem*  item =  (QComboTableItem *)_colorsetting->item(i, j);
      QString  line = Config::readEntry(QString(_colorsetting->name()) + "underline" + QString::number(i), "0");
      item->setCurrentItem(line.toInt());
    }
    break;

  case ST_ATOK:
  case ST_KINPUT2:
  case ST_MSIME:
  case ST_VJE:
    // Loads Color table
    for (i = 0; i < NUM_ROWS; i++) {
      for (j = 0; j < NUM_COLS - 1; j++) {
        QColor color( ColorSetting[index][i][j] );
        if ( color.isValid() ) {
          QPixmap  pix = _colorsetting->pixmap(i, j);
          pix.resize(_colorsetting->columnWidth(j), _colorsetting->rowHeight(i));
          pix.fill( color );
          _colorsetting->setPixmap(i, j, pix);
          _colorsetting->setText(i, j, color.name());
          qDebug("set color row: %d  col: %d  name: %s", i, j, color.name().data());
        }
      }
      
      QComboTableItem*  item =  (QComboTableItem *)_colorsetting->item(i, j);
      item->setCurrentItem((ColorSetting[index][i][j]).toInt());
      qDebug("set color row: %d  col: %d  name: %s", i, j, (const char*)ColorSetting[index][i][j].local8Bit());
    }
    break;

  default:
    break;
  }
}


void PropertyDialog::saveColorSetting()
{
  // Saves color table items
  int i, j;
  for (i = 0; i < NUM_ROWS; i++) {
    for (j = 0; j < NUM_COLS - 1; j++) {
      if ( _colorsetting->text(i, j) ) {
	Config::writeEntry(QString(_colorsetting->name()) + "color" + QString::number(i * 2 + j), 
			   _colorsetting->text(i, j) );
      }
    }
    
    int line = ((QComboTableItem*)_colorsetting->item(i, j))->currentItem(); 
    Config::writeEntry(QString(_colorsetting->name()) + "underline" + QString::number(i), 
		       QString::number(line));
  }
}


void PropertyDialog::saveDefaultSetting()
{
  Config::writeEntry("_cmbstartkey", QObject::tr("Zenkaku_Hankaku"), FALSE);
  Config::writeEntry("_cmbinputmode", QObject::tr("Ҥ餬"), FALSE);
  Config::writeEntry("_cmbinputstyle", QObject::tr("޻"), FALSE);
  Config::writeEntry("_chkdispbar", FALSE, FALSE);
  
  Config::writeEntry("_cmbspacekey", QObject::tr("Ⱦ"), FALSE);
  Config::writeEntry("_cmbtenkey", QObject::tr("Ⱦ"), FALSE);
  Config::writeEntry("_cmbtouten", QObject::tr(""), FALSE);
  Config::writeEntry("_cmbkuten", QObject::tr(""), FALSE);
  Config::writeEntry("_cmbsymbol", QObject::tr(""), FALSE);
  Config::writeEntry("_cmbbracket", QObject::tr("֡"), FALSE);
  
  Config::writeEntry("_cmbkanjisys", QObject::tr("canna"), FALSE);
  Config::writeEntry("_chkremote", FALSE, FALSE);
  Config::writeEntry("_edtsvrname", QString::null, FALSE);
  Config::writeEntry("_edtport", QString::null, FALSE);

  // Saves default color table items
  const int setting = ST_MSIME;
  int i, j;
  for (i = 0; i < NUM_ROWS; i++) {
    for (j = 0; j < NUM_COLS - 1; j++) {
      Config::writeEntry(QString("_colorsetting") + "color" + QString::number(i * 2 + j), 
			 ColorSetting[setting][i][j], FALSE);
    }
    
    Config::writeEntry(QString("_colorsetting") + "underline" + QString::number(i), 
		       ColorSetting[setting][i][j], FALSE);
  }
}


void PropertyDialog::PropertyDialog_destroyed( QObject * )
{

}
